unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids, IBDatabase, IBCustomDataSet, IBTable,
  StdCtrls, DBCtrls, Mask, ExtCtrls;

type
  TForm1 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBTable1: TIBTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    DBNavigator1: TDBNavigator;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Edit2: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure IBTable1AfterPost(DataSet: TDataSet);
    procedure IBTable1AfterDelete(DataSet: TDataSet);
    procedure IBTable1BeforeRefresh(DataSet: TDataSet);
  private
    { Private 錾 }
    AppPath : string ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   AppPath := ExtractFilePath(Application.ExeName);
   Label1.Caption := '';
   Label2.Caption := '';
   // NɃf[^x[X쐬܂
   // f[^x[X쐬
   IBDataBase1.DatabaseName := Edit1.Text + Edit2.Text + 'TEST.FDB' ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER "SYSDBA"');
   IBDatabase1.Params.Add('PASSWORD "masterkey"');
   IBDatabase1.Params.Add('PAGE_SIZE 4096');
   try
      IBDataBase1.CreateDatabase;
   except
      // ɍ쐬ς
   end;

   // f[^x[Xڑ
   IBDataBase1.DatabaseName := Edit1.Text + Edit2.Text + 'TEST.FDB' ;
   IBDataBase1.Connected := False ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER_NAME=SYSDBA');
   IBDatabase1.Params.Add('PASSWORD=masterkey');
   IBDatabase1.Connected := True ;
   IBTransaction1.Active := True ;

   // e[u쐬
   try
      with IBTable1 do begin
         TableName := 'TEST' ;
         if not(IBTable1.Exists) then begin
            StoreDefs := True ;
            // e[u̍
            with FieldDefs do begin
               Clear;
               with AddFieldDef do begin
                  Name := 'N';
                  DataType := ftInteger ;
                  Required :=True;
               end;
               with AddFieldDef do begin
                  Name := 'MOJIDATA';
                  DataType := ftString ;
                  Size := 20 ;
               end;
            end;
            // CfbNX
            with IndexDefs do begin
               Clear;
               with AddIndexDef do begin
                  Name := 'INDEX1';
                  Fields := 'N';
               end;
            end;
            //
            CreateTable;
         end;
      end;
   except
      ;
   end;
   IBTable1.StoreDefs := False ;
   IBDatabase1.Connected := False ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // ؒf
   Button2Click(Sender);
end;

// DBڑ
procedure TForm1.Button1Click(Sender: TObject);
begin
   if (IBTable1.Active) then
      IBDatabase1.ApplyUpdates([IBTable1]);

   IBDatabase1.Connected := True ;
   IBTransaction1.Active := True ;
   IBTable1.Active := True ;

   Label1.Caption := IBTable1.Fields[0].FieldName ;
   Label2.Caption := IBTable1.Fields[1].FieldName ;
   DBEdit1.DataField := IBTable1.Fields[0].FieldName ;
   DBEdit2.DataField := IBTable1.Fields[1].FieldName ;
end;

// DBؒf
procedure TForm1.Button2Click(Sender: TObject);
begin
   if (IBTable1.Active) then
      IBDatabase1.ApplyUpdates([IBTable1]);

   IBTable1.Active := False ;
   IBTransaction1.Active := False ;
   IBDatabase1.Connected := False ;
end;

procedure TForm1.IBTable1AfterPost(DataSet: TDataSet);
begin
   IBDatabase1.ApplyUpdates([IBTable1]);
end;

procedure TForm1.IBTable1AfterDelete(DataSet: TDataSet);
begin
   IBDatabase1.ApplyUpdates([IBTable1]);
end;

procedure TForm1.IBTable1BeforeRefresh(DataSet: TDataSet);
begin
   // XVOɈUčēxJ
   IBTable1.Active := False ;
   IBTransaction1.Active := False ;
   IBTransaction1.Active := True ;
   IBTable1.Active := True ;
end;

end.
